## octomap 1.6.8%2Bdfsg

=== dynamicEDT3D/src/CMakeLists.txt ===
SET( dynamicEDT3D_SRCS
   dynamicEDT3D.cpp
   dynamicEDTOctomap.cpp
   )

add_library(dynamicedt3d SHARED ${dynamicEDT3D_SRCS})
set_target_properties(dynamicedt3d PROPERTIES
  VERSION ${DYNAMICEDT3D_VERSION}
  SOVERSION ${DYNAMICEDT3D_SOVERSION}
)
target_link_libraries(dynamicedt3d ${OCTOMAP_LIBRARIES})

add_library(dynamicedt3d-static STATIC ${dynamicEDT3D_SRCS})
target_link_libraries(dynamicedt3d-static ${OCTOMAP_LIBRARIES})

SET_TARGET_PROPERTIES(dynamicedt3d-static PROPERTIES OUTPUT_NAME "dynamicedt3d") 

# directly depend on the octomap library target when building the
# complete distribution, so it it recompiled as needed
if (CMAKE_PROJECT_NAME STREQUAL "octomap-distribution")
  ADD_DEPENDENCIES(dynamicedt3d-static octomap-static)
  ADD_DEPENDENCIES(dynamicedt3d octomap)
endif()

ADD_SUBDIRECTORY(examples)

install(TARGETS 
  dynamicedt3d
  dynamicedt3d-static
  ${INSTALL_TARGETS_DEFAULT_ARGS})

=== octomap/src/testing/CMakeLists.txt ===

ADD_EXECUTABLE(test_raycasting test_raycasting.cpp)
TARGET_LINK_LIBRARIES(test_raycasting octomap)

ADD_EXECUTABLE(test_iterators test_iterators.cpp)
TARGET_LINK_LIBRARIES(test_iterators octomap)

ADD_EXECUTABLE(test_io test_io.cpp)
TARGET_LINK_LIBRARIES(test_io octomap)

ADD_EXECUTABLE(test_changedkeys test_changedkeys.cpp)
TARGET_LINK_LIBRARIES(test_changedkeys octomap)

ADD_EXECUTABLE(test_scans test_scans.cpp)
TARGET_LINK_LIBRARIES(test_scans octomap)

ADD_EXECUTABLE(test_lut test_lut.cpp)
TARGET_LINK_LIBRARIES(test_lut octomap)

ADD_EXECUTABLE(test_color_tree test_color_tree.cpp)
TARGET_LINK_LIBRARIES(test_color_tree octomap)

ADD_EXECUTABLE(color_tree_histogram color_tree_histogram.cpp)
TARGET_LINK_LIBRARIES(color_tree_histogram octomap)

ADD_EXECUTABLE(test_mapcollection test_mapcollection.cpp)
TARGET_LINK_LIBRARIES(test_mapcollection octomap octomath)

ADD_EXECUTABLE(test_pruning test_pruning.cpp)
TARGET_LINK_LIBRARIES(test_pruning octomap octomath)


# CTest tests below

ADD_EXECUTABLE(unit_tests unit_tests.cpp)
TARGET_LINK_LIBRARIES(unit_tests octomap)

ADD_TEST (NAME MathVector         COMMAND unit_tests MathVector     )
ADD_TEST (NAME MathPose           COMMAND unit_tests MathPose       )
ADD_TEST (NAME InsertRay          COMMAND unit_tests InsertRay      )
ADD_TEST (NAME InsertScan         COMMAND unit_tests InsertScan     )
ADD_TEST (NAME ReadGraph          COMMAND unit_tests ReadGraph      )
ADD_TEST (NAME StampedTree        COMMAND unit_tests StampedTree    )
ADD_TEST (NAME OcTreeKey          COMMAND unit_tests OcTreeKey      )
ADD_TEST (NAME test_raycasting    COMMAND test_raycasting)
ADD_TEST (NAME test_io            COMMAND test_io ${PROJECT_SOURCE_DIR}/share/data/geb079.bt)
ADD_TEST (NAME test_pruning       COMMAND test_pruning )
ADD_TEST (NAME test_iterators     COMMAND test_iterators ${PROJECT_SOURCE_DIR}/share/data/geb079.bt)
ADD_TEST (NAME test_mapcollection COMMAND test_mapcollection ${PROJECT_SOURCE_DIR}/share/data/mapcoll.txt)
ADD_TEST (NAME test_color_tree    COMMAND test_color_tree)

=== debian/control ===
Source: octomap
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>, Jose Luis Rivero <jrivero@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libqglviewer-dev-qt4
Standards-Version: 3.9.5
Homepage: http://octomap.github.io
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/octomap.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/octomap.git

Package: liboctomap1.6v5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: liboctomap1.6
Replaces: liboctomap1.6
Description: 3D occupancy grid mapping approach library for mapping 
 The OctoMap library implements a 3D occupancy grid mapping approach,
 providing data structures and mapping algorithms in C++ particularly suited
 for robotics. The map implementation is based on an octree and is designed
 to meet the following requirements: Full 3D model, Updatable, Flexible and
 Compact. This package contains the library itself.

Package: octomap-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for 3D occupancy grid mapping 
 The OctoMap library implements a 3D occupancy grid mapping approach,
 providing data structures and mapping algorithms in C++ particularly suited
 for robotics. The map implementation is based on an octree and is designed 
 to meet the following requirements: Full 3D model, Updatable, Flexible and 
 Compact. This package contains tools to use with Octomap library.

Package: liboctomap-dev
Architecture: any  
Section: libdevel  
Depends: liboctomap1.6v5 (= ${binary:Version}),
         ${misc:Depends}
Description: Octomap library development files
 The OctoMap library implements a 3D occupancy grid mapping approach,
 providing data structures and mapping algorithms in C++ particularly suited
 for robotics. The map implementation is based on an octree and is designed 
 to meet the following requirements: Full 3D model, Updatable, Flexible and 
 Compact. This package contains the development stuff.


Package: liboctomap1.6v5-dbg
Architecture: any   
Section: debug      
Priority: extra
Depends: liboctomap1.6v5 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: liboctomap1.6-dbg
Replaces: liboctomap1.6-dbg
Description: Octomap library debug development files
 The OctoMap library implements a 3D occupancy grid mapping approach,
 providing data structures and mapping algorithms in C++ particularly suited
 for robotics. The map implementation is based on an octree and is designed 
 to meet the following requirements: Full 3D model, Updatable, Flexible and 
 Compact. This package contains the debug stuff.


Package: libdynamicedt3d1.6
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Incrementally updatable Euclidean distance transform library
 The dynamicEDT3D library implements an incrementally updatable Euclidean
 distance transform (EDT) in 3D. It comes with a wrapper to use the OctoMap
 3D representation and hooks into the change detection of the OctoMap library
 to propagate changes to the EDT.

Package: libdynamicedt3d-dev
Architecture: any  
Section: libdevel  
Depends: libdynamicedt3d1.6 (= ${binary:Version}),
         ${misc:Depends}
Description: dynamicEDT3D library development files
 The dynamicEDT3D library implements an incrementally updatable Euclidean  
 distance transform (EDT) in 3D. It comes with a wrapper to use the OctoMap  
 3D representation and hooks into the change detection of the OctoMap library
 to propagate changes to the EDT. This package contains the development
 files.

Package: libdynamicedt3d1.6-dbg
Architecture: any   
Section: debug
Priority: extra     
Depends: libdynamicedt3d1.6 (= ${binary:Version}),
         ${misc:Depends}
Description: dynamicEDT3D library development - debug files
 The dynamicEDT3D library implements an incrementally updatable Euclidean
 distance transform (EDT) in 3D. It comes with a wrapper to use the OctoMap
 3D representation and hooks into the change detection of the OctoMap
 library to propagate changes to the EDT. This package contains the development
 debug info. 

Package: liboctovis1.6v5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: liboctovis1.6
Replaces: liboctovis1.6
Description: Visualization library for OctoMap 
 Visualization library for the OctoMap library based on Qt and libQGLViewer.
 This library encapsulates the functions to view a Octomap octrees. It
 provides an API to visualizate the octree.

Package: liboctovis-dev
Architecture: any  
Section: libdevel  
Depends: liboctovis1.6v5 (= ${binary:Version}),
         ${misc:Depends}
Description: Visualization library for OctoMap development files
 Visualization library for the OctoMap library based on Qt and libQGLViewer.
 This library encapsulates the functions to view a Octomap octrees. This package 
 contains the development files.

Package: liboctovis1.6v5-dbg
Architecture: any   
Priority: extra
Section: debug      
Depends: liboctovis1.6v5 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: liboctovis1.6-dbg
Replaces: liboctovis1.6-dbg
Description: Visualization library for OctoMap - debug files
 Visualization library for the OctoMap library based on Qt and libQGLViewer.
 This package contains the debug development files.

Package: octovis
Architecture: any   
Depends: liboctovis1.6v5 (= ${binary:Version}),
         ${misc:Depends}, ${shlibs:Depends},
	 libqglviewer2
Description: Visualization tool for OctoMap
 Visualization library for the OctoMap library based on Qt and libQGLViewer.
 This package contains the tool for visualization. It's a viewer that lets
 you view an OctoMap.

## octomap 1.6.8+dfsg

=== dynamicEDT3D/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(dynamicEDT3D)

ENABLE_TESTING()

# version (e.g. for packaging)
set(DYNAMICEDT3D_MAJOR_VERSION 1)
set(DYNAMICEDT3D_MINOR_VERSION 6)
set(DYNAMICEDT3D_PATCH_VERSION 8)
set(DYNAMICEDT3D_VERSION ${DYNAMICEDT3D_MAJOR_VERSION}.${DYNAMICEDT3D_MINOR_VERSION}.${DYNAMICEDT3D_PATCH_VERSION})
set(DYNAMICEDT3D_SOVERSION ${DYNAMICEDT3D_MAJOR_VERSION}.${DYNAMICEDT3D_MINOR_VERSION})

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

SET (CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules")

# COMPILER SETTINGS (default: Release) and flags
INCLUDE(CompilerSettings)


# Set output directories for libraries and executables
SET( BASE_DIR ${CMAKE_SOURCE_DIR} )
SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BASE_DIR}/bin )

set(INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
INCLUDE_DIRECTORIES(${INCLUDE_DIRS})

LINK_DIRECTORIES(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

# Installation

set(INSTALL_TARGETS_DEFAULT_ARGS
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

find_package(octomap REQUIRED
  HINTS ${CMAKE_SOURCE_DIR}/lib/cmake/octomap
   ${CMAKE_SOURCE_DIR}/../octomap/lib/cmake/octomap
)
INCLUDE_DIRECTORIES(${OCTOMAP_INCLUDE_DIRS})

ADD_SUBDIRECTORY(src)


file(GLOB dynamicEDT3D_HDRS ${PROJECT_SOURCE_DIR}/include/dynamicEDT3D/*.h ${PROJECT_SOURCE_DIR}/include/dynamicEDT3D/*.hxx)
install(FILES ${dynamicEDT3D_HDRS}	DESTINATION include/dynamicEDT3D)

# Install catkin package.xml, attention package.xml names the catkin package "dynamic_edt_3d", so this is also the location where it needs to be installed to (and not "dynamicEDT3D")
install(FILES package.xml DESTINATION share/dynamic_edt_3d)

#TODO: this conflicts with the octomap uninstall
#it is not only a target name problem, also both will use the same manifest file
#in the same binary directory
#configure_file(
#    "${PROJECT_SOURCE_DIR}/CMakeModules/CMakeUninstall.cmake.in"
#    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
#    IMMEDIATE @ONLY)
#
#add_custom_target(uninstall
#    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)


# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE dynamicEDT3D)
 
# Create a dynamicEDT3DConfig.cmake file for the use from the build tree
set(DYNAMICEDT3D_INCLUDE_DIRS "${INCLUDE_DIRS}")
set(DYNAMICEDT3D_LIB_DIR "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
# not used right now (export depends?)
#set(DYNEDT3D_CMAKE_DIR "${PROJECT_BINARY_DIR}")
configure_file(dynamicEDT3DConfig.cmake.in
  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/cmake/dynamicEDT3D/dynamicEDT3DConfig.cmake" @ONLY)
configure_file(dynamicEDT3DConfig-version.cmake.in
  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/cmake/dynamicEDT3D/dynamicEDT3DConfig-version.cmake" @ONLY)

# Install the export set for use with the install-tree
#install(EXPORT FooBarLibraryDepends DESTINATION
#  "${INSTALL_DATA_DIR}/FooBar/CMake"
#  COMPONENT dev)
 
# Create a dynamicEDT3DConfig.cmake file for the use from the install tree
# and install it
set(DYNAMICEDT3D_INCLUDE_DIRS "${CMAKE_INSTALL_PREFIX}/include")
set(DYNAMICEDT3D_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
#set(DYNAMICEDT3D_CMAKE_DIR "${INSTALL_DATA_DIR}/FooBar/CMake")
configure_file(dynamicEDT3DConfig.cmake.in
  "${PROJECT_BINARY_DIR}/InstallFiles/dynamicEDT3DConfig.cmake" @ONLY)
configure_file(dynamicEDT3DConfig-version.cmake.in
  "${PROJECT_BINARY_DIR}/InstallFiles/dynamicEDT3DConfig-version.cmake" @ONLY)
install(FILES
  "${PROJECT_BINARY_DIR}/InstallFiles/dynamicEDT3DConfig.cmake"
  "${PROJECT_BINARY_DIR}/InstallFiles/dynamicEDT3DConfig-version.cmake" 
  DESTINATION share/dynamicEDT3D/)

# Write pkgconfig-file:
include(InstallPkgConfigFile)
install_pkg_config_file(dynamicEDT3D
    CFLAGS
    LIBS -ldynamicEDT3D
    REQUIRES
    VERSION ${DYNAMICEDT3D_VERSION})


# Documentation 
FIND_PACKAGE(Doxygen)
IF(DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET(docs_dynamicEDT3D ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/dynamicEDT3D.dox
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generating documentation (Doxygen)...")
ENDIF(DOXYGEN_FOUND)

# Needs to be last statement:
INCLUDE(CPackSettings)

# Finished:
MESSAGE ("\n")
MESSAGE (STATUS "Compile dynamicEDT3D using: make")
MESSAGE (STATUS "Install dynamicEDT3D using: make install")
MESSAGE (STATUS "    (be sure to set the correct CMAKE_INSTALL_PREFIX before)")
MESSAGE (STATUS "Compile API-documentation using: make docs_dynamicEDT3D\n")

=== octomap/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT( octomap )

ENABLE_TESTING()

# version (e.g. for packaging)
set(OCTOMAP_MAJOR_VERSION 1)
set(OCTOMAP_MINOR_VERSION 6)
set(OCTOMAP_PATCH_VERSION 8)
set(OCTOMAP_VERSION ${OCTOMAP_MAJOR_VERSION}.${OCTOMAP_MINOR_VERSION}.${OCTOMAP_PATCH_VERSION})
set(OCTOMAP_SOVERSION ${OCTOMAP_MAJOR_VERSION}.${OCTOMAP_MINOR_VERSION})
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

SET (CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules")

# COMPILER SETTINGS (default: Release) and flags
INCLUDE(CompilerSettings)

# OCTOMAP_OMP = enable OpenMP parallelization (experimental, defaults to OFF)
SET(OCTOMAP_OMP FALSE CACHE BOOL "Enable/disable OpenMP parallelization")
IF(DEFINED ENV{OCTOMAP_OMP})
  SET(OCTOMAP_OMP $ENV{OCTOMAP_OMP})
ENDIF(DEFINED ENV{OCTOMAP_OMP})
IF(OCTOMAP_OMP)
  FIND_PACKAGE( OpenMP REQUIRED)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
ENDIF(OCTOMAP_OMP)

# Set output directories for libraries and executables
SET( BASE_DIR ${CMAKE_SOURCE_DIR} )
SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BASE_DIR}/bin )

set(INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
INCLUDE_DIRECTORIES(${INCLUDE_DIRS})

LINK_DIRECTORIES(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

# Installation

set(INSTALL_TARGETS_DEFAULT_ARGS
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

ADD_SUBDIRECTORY( src/math )
ADD_SUBDIRECTORY( src )

file(GLOB octomap_HDRS ${PROJECT_SOURCE_DIR}/include/octomap/*.h ${PROJECT_SOURCE_DIR}/include/octomap/*.hxx)
install(FILES ${octomap_HDRS}	DESTINATION include/octomap)
file(GLOB octomap_math_HDRS ${PROJECT_SOURCE_DIR}/include/octomap/math/*.h)
install(FILES ${octomap_math_HDRS}	DESTINATION include/octomap/math)

# Install catkin package.xml
install(FILES package.xml DESTINATION share/octomap)

# uninstall target
configure_file(
    "${PROJECT_SOURCE_DIR}/CMakeModules/CMakeUninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)


# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE octomap)
 
# Create a octomap-config.cmake file for the use from the build tree
set(OCTOMAP_INCLUDE_DIRS "${INCLUDE_DIRS}")
set(OCTOMAP_LIB_DIR "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
# not used right now (export depends?)
#set(OCTOMAP_CMAKE_DIR "${PROJECT_BINARY_DIR}")
configure_file(octomap-config.cmake.in
  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/cmake/octomap/octomap-config.cmake" @ONLY)
configure_file(octomap-config-version.cmake.in
  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/cmake/octomap/octomap-config-version.cmake" @ONLY)

# Install the export set for use with the install-tree
#install(EXPORT FooBarLibraryDepends DESTINATION
#  "${INSTALL_DATA_DIR}/FooBar/CMake"
#  COMPONENT dev)
 
# Create a octomap-config.cmake file for the use from the install tree
# and install it
set(OCTOMAP_INCLUDE_DIRS "${CMAKE_INSTALL_PREFIX}/include")
set(OCTOMAP_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
#set(OCTOMAP_CMAKE_DIR "${INSTALL_DATA_DIR}/FooBar/CMake")
configure_file(octomap-config.cmake.in
  "${PROJECT_BINARY_DIR}/InstallFiles/octomap-config.cmake" @ONLY)
configure_file(octomap-config-version.cmake.in
  "${PROJECT_BINARY_DIR}/InstallFiles/octomap-config-version.cmake" @ONLY)
install(FILES
  "${PROJECT_BINARY_DIR}/InstallFiles/octomap-config.cmake"
  "${PROJECT_BINARY_DIR}/InstallFiles/octomap-config-version.cmake" 
  DESTINATION share/octomap/)

# Write pkgconfig-file:
include(InstallPkgConfigFile)
install_pkg_config_file(octomap
    CFLAGS
    LIBS -loctomap -loctomath
    REQUIRES
    VERSION ${OCTOMAP_VERSION})

# Documentation 
FIND_PACKAGE(Doxygen)
IF(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/octomap.dox.in ${CMAKE_CURRENT_BINARY_DIR}/octomap.dox @ONLY)
  ADD_CUSTOM_TARGET(docs ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/octomap.dox
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generating documentation (Doxygen) at location ${PROJECT_SOURCE_DIR}/doc/html/")
ENDIF(DOXYGEN_FOUND)

# Needs to be last statement:
INCLUDE(CPackSettings)

# Finished:
MESSAGE ("\n")
MESSAGE (STATUS "Compile octomap using: make")
MESSAGE (STATUS "Install octomap using: make install")
MESSAGE (STATUS "    (be sure to set the correct CMAKE_INSTALL_PREFIX before)")
MESSAGE (STATUS "Compile API-documentation using: make docs\n")

=== octovis/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT( octovis )

# # version (e.g. for packaging)
set(OCTOVIS_MAJOR_VERSION 1)
set(OCTOVIS_MINOR_VERSION 6)
set(OCTOVIS_PATCH_VERSION 8)
set(OCTOVIS_VERSION ${OCTOVIS_MAJOR_VERSION}.${OCTOVIS_MINOR_VERSION}.${OCTOVIS_PATCH_VERSION})
set(OCTOVIS_SOVERSION ${OCTOVIS_MAJOR_VERSION}.${OCTOVIS_MINOR_VERSION})
# get rid of a useless warning:
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

SET (CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules")

# COMPILER SETTINGS (default: Release) and flags
INCLUDE(CompilerSettings)

# Set output directories for libraries and executables
SET( BASE_DIR ${CMAKE_SOURCE_DIR} )
SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BASE_DIR}/bin )

# We need the main octomap library to link against (same version as octovis)
# Look at parent directory by default, in case the complete distribution
# (octomap & octovis together) is built.
#
# Otherwise you need to export octomap_DIR to the directory containing
# the file octomap-config.cmake
find_package(octomap ${OCTOVIS_MAJOR_VERSION}.${OCTOVIS_MINOR_VERSION} REQUIRED
HINTS ${CMAKE_SOURCE_DIR}/lib/cmake/octomap
${CMAKE_SOURCE_DIR}/../octomap/lib/cmake/octomap
)
MESSAGE(STATUS "Found octomap version: " ${octomap_VERSION})

INCLUDE_DIRECTORIES(${OCTOMAP_INCLUDE_DIRS})

# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE octovis)

set(INSTALL_TARGETS_DEFAULT_ARGS
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

# Builds the "octovis" viewer based on OpenGL and 
# libQGLViewer, if dependencies available
SET( BUILD_VIEWER 0)

# Look for required libraries:
FIND_PACKAGE(OpenGL)
FIND_PACKAGE(Qt4)
IF (OpenGL-NOTFOUND OR Qt4-NOTFOUND) 
	MESSAGE ( "OpenGL and QT4 are required for octovis but could not be found.")	
ELSE()
	FIND_PACKAGE(QGLViewer)
	IF(QGLViewer_FOUND)
	  SET( BUILD_VIEWER 1)
	ELSE()
	  MESSAGE ( "\n")
  	MESSAGE ( "libQGLViewer could not be found or generated.")
	ENDIF()
ENDIF()


IF(BUILD_VIEWER)
  MESSAGE(STATUS "\n")
  MESSAGE(STATUS "viewer octovis will be built")
  
  set(INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
  INCLUDE_DIRECTORIES(${INCLUDE_DIRS})
   
  INCLUDE( CMakeLists_src.txt )
    
  # Create an octovis-config.cmake file for the use from the build tree
  set(OCTOVIS_INCLUDE_DIR "${INCLUDE_DIRS}")
  set(OCTOVIS_LIB_DIR     "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
  # not used right now (export depends?)
  #set(OCTOMAP_CMAKE_DIR "${PROJECT_BINARY_DIR}")
  configure_file(octovis-config.cmake.in
    "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/cmake/octovis/octovis-config.cmake" @ONLY)
  configure_file(octovis-config-version.cmake.in
    "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/cmake/octovis/octovis-config-version.cmake" @ONLY)  
    
  # Create a octovis-config.cmake file for the use from the install tree
  # and install it
  set(OCTOVIS_INCLUDE_DIRS "${CMAKE_INSTALL_PREFIX}/include")
  set(OCTOVIS_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
  #set(OCTOMAP_CMAKE_DIR "${INSTALL_DATA_DIR}/FooBar/CMake")
  configure_file(octovis-config.cmake.in
    "${PROJECT_BINARY_DIR}/InstallFiles/octovis-config.cmake" @ONLY)
  configure_file(octovis-config-version.cmake.in
    "${PROJECT_BINARY_DIR}/InstallFiles/octovis-config-version.cmake" @ONLY)
  install(FILES
    "${PROJECT_BINARY_DIR}/InstallFiles/octovis-config.cmake"
    "${PROJECT_BINARY_DIR}/InstallFiles/octovis-config-version.cmake" 
    DESTINATION share/octovis/)
    
    
  # #installation:
  # # store all header files to install:
  file(GLOB octovis_HDRS  *.h *.hxx *.hpp)
  install(FILES ${octovis_HDRS} DESTINATION include/octovis)

  # Install catkin package.xml
  install(FILES package.xml DESTINATION share/octovis)
  
ELSE()
    MESSAGE ( "Unfortunately, the viewer (octovis) can not be built because some requirements are missing.")
	MESSAGE ( "This will not affect the compilation of the stand-alone library and tools (octomap)")
    MESSAGE ( "See README.txt or http://octomap.sf.net for further information.\n")
ENDIF()

=== octomap/src/CMakeLists.txt ===
SET (octomap_SRCS
  AbstractOcTree.cpp
  AbstractOccupancyOcTree.cpp
  Pointcloud.cpp
  ScanGraph.cpp
  CountingOcTree.cpp
  OcTree.cpp
  OcTreeNode.cpp
  OcTreeStamped.cpp
  OcTreeLUT.cpp
  ColorOcTree.cpp
  )

# dynamic and static libs, see CMake FAQ:
ADD_LIBRARY( octomap SHARED ${octomap_SRCS})
set_target_properties( octomap PROPERTIES
  VERSION ${OCTOMAP_VERSION}
  SOVERSION ${OCTOMAP_SOVERSION}
)
ADD_LIBRARY( octomap-static STATIC ${octomap_SRCS})
SET_TARGET_PROPERTIES(octomap-static PROPERTIES OUTPUT_NAME "octomap") 

TARGET_LINK_LIBRARIES(octomap octomath)

ADD_SUBDIRECTORY( testing )

ADD_EXECUTABLE(graph2tree graph2tree.cpp)
TARGET_LINK_LIBRARIES(graph2tree octomap)

ADD_EXECUTABLE(log2graph log2graph.cpp)
TARGET_LINK_LIBRARIES(log2graph octomap)

ADD_EXECUTABLE(binvox2bt binvox2bt.cpp)
TARGET_LINK_LIBRARIES(binvox2bt octomap)

ADD_EXECUTABLE(bt2vrml bt2vrml.cpp)
TARGET_LINK_LIBRARIES(bt2vrml octomap)

ADD_EXECUTABLE(edit_octree edit_octree.cpp)
TARGET_LINK_LIBRARIES(edit_octree octomap)

ADD_EXECUTABLE(convert_octree convert_octree.cpp)
TARGET_LINK_LIBRARIES(convert_octree octomap)

ADD_EXECUTABLE(eval_octree_accuracy eval_octree_accuracy.cpp)
TARGET_LINK_LIBRARIES(eval_octree_accuracy octomap)

ADD_EXECUTABLE(compare_octrees compare_octrees.cpp)
TARGET_LINK_LIBRARIES(compare_octrees octomap)

ADD_EXECUTABLE(simple_example simple_example.cpp)
TARGET_LINK_LIBRARIES(simple_example octomap)

ADD_EXECUTABLE(normals_example normals_example.cpp)
TARGET_LINK_LIBRARIES(normals_example octomap)

ADD_EXECUTABLE(intersection_example intersection_example.cpp)
TARGET_LINK_LIBRARIES(intersection_example octomap)


# installation:
# store all header files to install:
# file(GLOB octomap_impl_HDRS *.h *.hxx *.hpp)
# install(FILES ${octomap_impl_HDRS} DESTINATION include/octomap)

install(TARGETS 
	octomap
	octomap-static 
	graph2tree
	log2graph
	binvox2bt
	bt2vrml
	edit_octree
	convert_octree
	eval_octree_accuracy
	compare_octrees
	${INSTALL_TARGETS_DEFAULT_ARGS}
)

=== dynamicEDT3D/src/examples/CMakeLists.txt ===
add_executable(exampleEDT3D exampleEDT3D.cpp)
target_link_libraries(exampleEDT3D dynamicedt3d)

add_executable(exampleEDTOctomap exampleEDTOctomap.cpp)
target_link_libraries(exampleEDTOctomap dynamicedt3d)

=== octomap/src/math/CMakeLists.txt ===
SET (octomath_SRCS
  Vector3.cpp
  Quaternion.cpp
  Pose6D.cpp
 )


ADD_LIBRARY( octomath SHARED ${octomath_SRCS})

SET_TARGET_PROPERTIES( octomath PROPERTIES
  VERSION ${OCTOMAP_VERSION}
  SOVERSION ${OCTOMAP_SOVERSION}
  INSTALL_NAME_DIR ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}   # this seems to be necessary for MacOS X
)
# INSTALL_NAME_DIR seems to be necessary for MacOS X

ADD_LIBRARY( octomath-static STATIC ${octomath_SRCS})
SET_TARGET_PROPERTIES(octomath-static PROPERTIES OUTPUT_NAME "octomath")

install(TARGETS octomath octomath-static ${INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
octomap (1.6.8+dfsg-2.1) unstable; urgency=medium

  * Rename library packages for g++5 ABI transition. (Closes: #791221)
  * debian/rules: Fix paths according to previous renames.

 -- Martin Pitt <mpitt@debian.org>  Wed, 05 Aug 2015 15:36:45 +0200

octomap (1.6.8+dfsg-2) unstable; urgency=medium

  * Team upload.
  * [6fa12fd] Fix compilation against qglviewer-qt4.

 -- Anton Gladky <gladk@debian.org>  Tue, 30 Jun 2015 22:36:13 +0200

octomap (1.6.8+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Updating install files.
  * Added upstream changelog.
  * Updating lintian-overrides files.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 29 Sep 2014 11:13:53 +0200

octomap (1.6.6+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #742709)
  * Repackaged to avoid unneeded files.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 20 May 2014 10:04:15 +0200

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_OPTIONS += nocheck

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filterparallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
#unexport CFLAGS  
#unexport CXXFLAGS
#unexport LDFLAGS

CMAKE_FLAGS = \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_VERBOSE_MAKEFILE=ON \
        -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
        -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
        -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
        -DCMAKE_SKIP_INSTALL_RPATH=TRUE
%:
	dh $@ --builddirectory=build --buildsystem=cmake --parallel

override_dh_clean:
	rm -rf build bin lib
	dh_clean

override_dh_auto_configure:
	mkdir -p build
	dh_auto_configure --builddirectory=build -- $(CMAKE_FLAGS) $(CMAKE_ARCH_FLAGS)


override_dh_auto_build:
	cd build && $(MAKE) 

override_dh_auto_install:
	dh_auto_install --builddirectory=build

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/liboctomap1.6v5-dbg && cp debian/README.Debug debian/tmp/usr/share/doc/liboctomap1.6v5-dbg/
	mkdir -p debian/tmp/usr/share/doc/liboctovis1.6v5-dbg && cp debian/README.Debug debian/tmp/usr/share/doc/liboctovis1.6v5-dbg/
	mkdir -p debian/tmp/usr/share/doc/libdynamicedt3d1.6-dbg && cp debian/README.Debug debian/tmp/usr/share/doc/libdynamicedt3d1.6-dbg/
	mkdir -p debian/tmp/usr/share/doc/liboctomap1.6v5 debian/tmp/usr/share/doc/libdynamicedt3d1.6
	gzip -n -c -9 octomap/CHANGELOG.txt > debian/tmp/usr/share/doc/liboctomap1.6v5/changelog.gz
	gzip -n -c -9 dynamicEDT3D/CHANGELOG.txt > debian/tmp/usr/share/doc/libdynamicedt3d1.6/changelog.gz
	dh_install --list-missing

override_dh_auto_test:
	echo "Supressing upstream tests"

override_dh_installdocs:
	dh_installdocs -pliboctovis-dev --link-doc=liboctomap1.6v5
	dh_installdocs -poctomap-tools --link-doc=liboctomap1.6v5
	dh_installdocs -pliboctovis1.6 --link-doc=liboctomap1.6v5
	dh_installdocs -poctovis --link-doc=liboctomap1.6v5
	dh_installdocs -pliboctomap-dev --link-doc=liboctomap1.6v5
	dh_installdocs -plibdynamicedt3d-dev --link-doc=libdynamicedt3d1.6
	dh_installdocs

override_dh_strip:
	dh_strip -pliboctomap1.6v5 --dbg-package=liboctomap1.6v5-dbg
	dh_strip -pliboctovis1.6v5 --dbg-package=liboctovis1.6v5-dbg
	dh_strip -plibdynamicedt3d1.6 --dbg-package=libdynamicedt3d1.6-dbg
	dh_strip -poctomap-tools
	dh_strip -poctovis

get-orig-source:
	uscan --verbose --force-download --repack --compress xz

=== debian/watch ===
# Watch control file for uscan
# Compulsory line, this is a version 3 file
version=3

# For GitHub projects you can use the tags page:
#opts=dversionmangle=s/\+dfsg// \
opts=uversionmangle=s/$/+dfsg/ \
 https://github.com/OctoMap/octomap/tags .*/v?(\d\S*)\.tar\.gz

## octomap 1.8.0+dfsg

=== dynamicEDT3D/CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,8 @@
 
 # version (e.g. for packaging)
 set(DYNAMICEDT3D_MAJOR_VERSION 1)
-set(DYNAMICEDT3D_MINOR_VERSION 6)
-set(DYNAMICEDT3D_PATCH_VERSION 8)
+set(DYNAMICEDT3D_MINOR_VERSION 8)
+set(DYNAMICEDT3D_PATCH_VERSION 0)
 set(DYNAMICEDT3D_VERSION ${DYNAMICEDT3D_MAJOR_VERSION}.${DYNAMICEDT3D_MINOR_VERSION}.${DYNAMICEDT3D_PATCH_VERSION})
 set(DYNAMICEDT3D_SOVERSION ${DYNAMICEDT3D_MAJOR_VERSION}.${DYNAMICEDT3D_MINOR_VERSION})
 
@@ -25,6 +25,13 @@
 SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
 SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
 SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BASE_DIR}/bin )
+# output dirs for multi-config builds (MSVC)
+foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
+  STRING( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
+  SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/lib )
+  SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/lib )
+  SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/bin )
+endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )
 
 set(INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
 INCLUDE_DIRECTORIES(${INCLUDE_DIRS})
@@ -43,6 +50,9 @@
   HINTS ${CMAKE_SOURCE_DIR}/lib/cmake/octomap
    ${CMAKE_SOURCE_DIR}/../octomap/lib/cmake/octomap
 )
+MESSAGE(STATUS "Found octomap version: " ${octomap_VERSION})
+MESSAGE(STATUS "octomap libraries: ${OCTOMAP_LIBRARIES}")
+
 INCLUDE_DIRECTORIES(${OCTOMAP_INCLUDE_DIRS})
 
 ADD_SUBDIRECTORY(src)
@@ -73,6 +83,17 @@
 # Create a dynamicEDT3DConfig.cmake file for the use from the build tree
 set(DYNAMICEDT3D_INCLUDE_DIRS "${INCLUDE_DIRS}")
 set(DYNAMICEDT3D_LIB_DIR "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
+# Set library names as absolute paths
+# Windows, spec. MSVC requires the .lib suffix for imported libs
+IF(WIN32)
+  set(DYNAMICEDT3D_LIBRARY
+    "${CMAKE_IMPORT_LIBRARY_PREFIX}dynamicedt3d${CMAKE_IMPORT_LIBRARY_SUFFIX}"
+  )
+ELSE()
+  set(DYNAMICEDT3D_LIBRARY
+    "${CMAKE_SHARED_LIBRARY_PREFIX}dynamicedt3d${CMAKE_SHARED_LIBRARY_SUFFIX}"
+  )
+ENDIF()
 # not used right now (export depends?)
 #set(DYNEDT3D_CMAKE_DIR "${PROJECT_BINARY_DIR}")
 configure_file(dynamicEDT3DConfig.cmake.in

=== octomap/CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,8 @@
 
 # version (e.g. for packaging)
 set(OCTOMAP_MAJOR_VERSION 1)
-set(OCTOMAP_MINOR_VERSION 6)
-set(OCTOMAP_PATCH_VERSION 8)
+set(OCTOMAP_MINOR_VERSION 8)
+set(OCTOMAP_PATCH_VERSION 0)
 set(OCTOMAP_VERSION ${OCTOMAP_MAJOR_VERSION}.${OCTOMAP_MINOR_VERSION}.${OCTOMAP_PATCH_VERSION})
 set(OCTOMAP_SOVERSION ${OCTOMAP_MAJOR_VERSION}.${OCTOMAP_MINOR_VERSION})
 if(COMMAND cmake_policy)
@@ -35,6 +35,13 @@
 SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
 SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
 SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BASE_DIR}/bin )
+# output dirs for multi-config builds (MSVC)
+foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
+  STRING( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
+  SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/lib )
+  SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/lib )
+  SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/bin )
+endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )
 
 set(INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
 INCLUDE_DIRECTORIES(${INCLUDE_DIRS})
@@ -69,7 +76,6 @@
 add_custom_target(uninstall
     COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
 
-
 # Export the package for use from the build-tree
 # (this registers the build-tree with a global CMake-registry)
 export(PACKAGE octomap)
@@ -77,6 +83,24 @@
 # Create a octomap-config.cmake file for the use from the build tree
 set(OCTOMAP_INCLUDE_DIRS "${INCLUDE_DIRS}")
 set(OCTOMAP_LIB_DIR "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
+# Set library names as absolute paths
+# Windows, spec. MSVC requires the .lib suffix for imported libs
+IF(WIN32)
+  set(OCTOMAP_LIBRARY
+    "${CMAKE_IMPORT_LIBRARY_PREFIX}octomap${CMAKE_IMPORT_LIBRARY_SUFFIX}"
+  )
+  set(OCTOMATH_LIBRARY
+    "${CMAKE_IMPORT_LIBRARY_PREFIX}octomath${CMAKE_IMPORT_LIBRARY_SUFFIX}"
+  )
+ELSE()
+  set(OCTOMAP_LIBRARY
+    "${CMAKE_SHARED_LIBRARY_PREFIX}octomap${CMAKE_SHARED_LIBRARY_SUFFIX}"
+  )
+  set(OCTOMATH_LIBRARY
+    "${CMAKE_SHARED_LIBRARY_PREFIX}octomath${CMAKE_SHARED_LIBRARY_SUFFIX}"
+  )
+ENDIF()
+
 # not used right now (export depends?)
 #set(OCTOMAP_CMAKE_DIR "${PROJECT_BINARY_DIR}")
 configure_file(octomap-config.cmake.in
@@ -84,16 +108,13 @@
 configure_file(octomap-config-version.cmake.in
   "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/cmake/octomap/octomap-config-version.cmake" @ONLY)
 
-# Install the export set for use with the install-tree
-#install(EXPORT FooBarLibraryDepends DESTINATION
-#  "${INSTALL_DATA_DIR}/FooBar/CMake"
-#  COMPONENT dev)
- 
+
 # Create a octomap-config.cmake file for the use from the install tree
 # and install it
 set(OCTOMAP_INCLUDE_DIRS "${CMAKE_INSTALL_PREFIX}/include")
 set(OCTOMAP_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
 #set(OCTOMAP_CMAKE_DIR "${INSTALL_DATA_DIR}/FooBar/CMake")
+
 configure_file(octomap-config.cmake.in
   "${PROJECT_BINARY_DIR}/InstallFiles/octomap-config.cmake" @ONLY)
 configure_file(octomap-config-version.cmake.in

=== octovis/CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,8 @@
 
 # # version (e.g. for packaging)
 set(OCTOVIS_MAJOR_VERSION 1)
-set(OCTOVIS_MINOR_VERSION 6)
-set(OCTOVIS_PATCH_VERSION 8)
+set(OCTOVIS_MINOR_VERSION 8)
+set(OCTOVIS_PATCH_VERSION 0)
 set(OCTOVIS_VERSION ${OCTOVIS_MAJOR_VERSION}.${OCTOVIS_MINOR_VERSION}.${OCTOVIS_PATCH_VERSION})
 set(OCTOVIS_SOVERSION ${OCTOVIS_MAJOR_VERSION}.${OCTOVIS_MINOR_VERSION})
 # get rid of a useless warning:
@@ -22,6 +22,13 @@
 SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
 SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${BASE_DIR}/lib )
 SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BASE_DIR}/bin )
+# output dirs for multi-config builds (MSVC)
+foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
+  STRING( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
+  SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/lib )
+  SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/lib )
+  SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${BASE_DIR}/bin )
+endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )
 
 # We need the main octomap library to link against (same version as octovis)
 # Look at parent directory by default, in case the complete distribution
@@ -79,6 +86,18 @@
   # Create an octovis-config.cmake file for the use from the build tree
   set(OCTOVIS_INCLUDE_DIR "${INCLUDE_DIRS}")
   set(OCTOVIS_LIB_DIR     "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
+  # Set library names as absolute paths
+  # Windows, spec. MSVC requires the .lib suffix for imported libs
+  IF(WIN32)
+    set(OCTOVIS_LIBRARY
+      "${CMAKE_IMPORT_LIBRARY_PREFIX}octovis${CMAKE_IMPORT_LIBRARY_SUFFIX}"
+    )
+  ELSE()
+    set(OCTOVIS_LIBRARY
+      "${CMAKE_SHARED_LIBRARY_PREFIX}octovis${CMAKE_SHARED_LIBRARY_SUFFIX}"
+    )
+  ENDIF()
+
   # not used right now (export depends?)
   #set(OCTOMAP_CMAKE_DIR "${PROJECT_BINARY_DIR}")
   configure_file(octovis-config.cmake.in

=== octomap/src/testing/CMakeLists.txt ===
--- 
+++ 
@@ -13,9 +13,6 @@
 
 ADD_EXECUTABLE(test_scans test_scans.cpp)
 TARGET_LINK_LIBRARIES(test_scans octomap)
-
-ADD_EXECUTABLE(test_lut test_lut.cpp)
-TARGET_LINK_LIBRARIES(test_lut octomap)
 
 ADD_EXECUTABLE(test_color_tree test_color_tree.cpp)
 TARGET_LINK_LIBRARIES(test_color_tree octomap)

=== debian/changelog ===
octomap (1.8.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Disable otcovis on armel and armhf

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 13 Sep 2016 14:51:54 +0200

octomap (1.8.0+dfsg-2) unstable; urgency=medium

  * Uploaded version to unstable.
  * Transition initiated to 1.8.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 15 Jun 2016 10:13:41 +0200

octomap (1.8.0+dfsg-1) experimental; urgency=medium

  * New upstream version.
  * Imported Upstream version 1.8.0+dfsg
  * Dropped unused patches
  * Renamed files because soname bump
  * Dropped dbg packages because new debhelper utility
  * Dropped unneeded part
  * Updated copyright
  * Bumped Standards-Version to 3.9.8. No changes

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Fri, 10 Jun 2016 09:32:39 +0200

octomap (1.6.8+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Use HTTPS in Vcs-* fields.
  * Drop explicit dependency on libqglviewer2, it gets automatically added.
    (Closes: #826203)

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 03 Jun 2016 09:48:09 +0000

## octomap 1.8.1%2Bdfsg

=== octomap/src/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,6 @@
   OcTree.cpp
   OcTreeNode.cpp
   OcTreeStamped.cpp
-  OcTreeLUT.cpp
   ColorOcTree.cpp
   )
 
@@ -57,11 +56,8 @@
 ADD_EXECUTABLE(intersection_example intersection_example.cpp)
 TARGET_LINK_LIBRARIES(intersection_example octomap)
 
-
-# installation:
-# store all header files to install:
-# file(GLOB octomap_impl_HDRS *.h *.hxx *.hpp)
-# install(FILES ${octomap_impl_HDRS} DESTINATION include/octomap)
+ADD_EXECUTABLE(octree2pointcloud octree2pointcloud.cpp)
+TARGET_LINK_LIBRARIES(octree2pointcloud octomap)
 
 install(TARGETS 
 	octomap

## octomap 1.8.1+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT( octomap-distribution )

ENABLE_TESTING()  # enable CTest environment of subprojects

option(BUILD_OCTOVIS_SUBPROJECT "Build targets from subproject octovis" ON)
option(BUILD_DYNAMICETD3D_SUBPROJECT  "Build targets from subproject dynamicEDT3D" ON)

ADD_SUBDIRECTORY( octomap )

if(BUILD_OCTOVIS_SUBPROJECT)
	ADD_SUBDIRECTORY( octovis )
endif()		

if(BUILD_DYNAMICETD3D_SUBPROJECT)	
	ADD_SUBDIRECTORY( dynamicEDT3D )
endif()

=== dynamicEDT3D/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 # version (e.g. for packaging)
 set(DYNAMICEDT3D_MAJOR_VERSION 1)
 set(DYNAMICEDT3D_MINOR_VERSION 8)
-set(DYNAMICEDT3D_PATCH_VERSION 0)
+set(DYNAMICEDT3D_PATCH_VERSION 1)
 set(DYNAMICEDT3D_VERSION ${DYNAMICEDT3D_MAJOR_VERSION}.${DYNAMICEDT3D_MINOR_VERSION}.${DYNAMICEDT3D_PATCH_VERSION})
 set(DYNAMICEDT3D_SOVERSION ${DYNAMICEDT3D_MAJOR_VERSION}.${DYNAMICEDT3D_MINOR_VERSION})

=== octomap/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 # version (e.g. for packaging)
 set(OCTOMAP_MAJOR_VERSION 1)
 set(OCTOMAP_MINOR_VERSION 8)
-set(OCTOMAP_PATCH_VERSION 0)
+set(OCTOMAP_PATCH_VERSION 1)
 set(OCTOMAP_VERSION ${OCTOMAP_MAJOR_VERSION}.${OCTOMAP_MINOR_VERSION}.${OCTOMAP_PATCH_VERSION})
 set(OCTOMAP_SOVERSION ${OCTOMAP_MAJOR_VERSION}.${OCTOMAP_MINOR_VERSION})
 if(COMMAND cmake_policy)

=== octovis/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # # version (e.g. for packaging)
 set(OCTOVIS_MAJOR_VERSION 1)
 set(OCTOVIS_MINOR_VERSION 8)
-set(OCTOVIS_PATCH_VERSION 0)
+set(OCTOVIS_PATCH_VERSION 1)
 set(OCTOVIS_VERSION ${OCTOVIS_MAJOR_VERSION}.${OCTOVIS_MINOR_VERSION}.${OCTOVIS_PATCH_VERSION})
 set(OCTOVIS_SOVERSION ${OCTOVIS_MAJOR_VERSION}.${OCTOVIS_MINOR_VERSION})
 # get rid of a useless warning:

=== octomap/src/testing/CMakeLists.txt ===
--- 
+++ 
@@ -39,6 +39,7 @@
 ADD_TEST (NAME ReadGraph          COMMAND unit_tests ReadGraph      )
 ADD_TEST (NAME StampedTree        COMMAND unit_tests StampedTree    )
 ADD_TEST (NAME OcTreeKey          COMMAND unit_tests OcTreeKey      )
+ADD_TEST (NAME test_scans         COMMAND test_scans ${PROJECT_SOURCE_DIR}/share/data/spherical_scan.graph)
 ADD_TEST (NAME test_raycasting    COMMAND test_raycasting)
 ADD_TEST (NAME test_io            COMMAND test_io ${PROJECT_SOURCE_DIR}/share/data/geb079.bt)
 ADD_TEST (NAME test_pruning       COMMAND test_pruning )

=== debian/changelog ===
octomap (1.8.1+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 24 Jan 2017 15:30:49 +0100

=== debian/control ===
Source: octomap
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>, Jose Luis Rivero <jrivero@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libqglviewer-dev-qt4 [!armel !armhf]
Standards-Version: 3.9.8
Homepage: http://octomap.github.io
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/octomap.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/octomap.git

Package: liboctomap1.8
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3D occupancy grid mapping approach library for mapping 
 The OctoMap library implements a 3D occupancy grid mapping approach,
 providing data structures and mapping algorithms in C++ particularly suited
 for robotics. The map implementation is based on an octree and is designed
 to meet the following requirements: Full 3D model, Updatable, Flexible and
 Compact. This package contains the library itself.

Package: octomap-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for 3D occupancy grid mapping 
 The OctoMap library implements a 3D occupancy grid mapping approach,
 providing data structures and mapping algorithms in C++ particularly suited
 for robotics. The map implementation is based on an octree and is designed 
 to meet the following requirements: Full 3D model, Updatable, Flexible and 
 Compact. This package contains tools to use with Octomap library.

Package: liboctomap-dev
Architecture: any  
Section: libdevel  
Depends: liboctomap1.8 (= ${binary:Version}),
         ${misc:Depends}
Description: Octomap library development files
 The OctoMap library implements a 3D occupancy grid mapping approach,
 providing data structures and mapping algorithms in C++ particularly suited
 for robotics. The map implementation is based on an octree and is designed 
 to meet the following requirements: Full 3D model, Updatable, Flexible and 
 Compact. This package contains the development stuff.

Package: libdynamicedt3d1.8
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Incrementally updatable Euclidean distance transform library
 The dynamicEDT3D library implements an incrementally updatable Euclidean
 distance transform (EDT) in 3D. It comes with a wrapper to use the OctoMap
 3D representation and hooks into the change detection of the OctoMap library
 to propagate changes to the EDT.

Package: libdynamicedt3d-dev
Architecture: any  
Section: libdevel  
Depends: libdynamicedt3d1.8 (= ${binary:Version}),
         ${misc:Depends}
Description: dynamicEDT3D library development files
 The dynamicEDT3D library implements an incrementally updatable Euclidean  
 distance transform (EDT) in 3D. It comes with a wrapper to use the OctoMap  
 3D representation and hooks into the change detection of the OctoMap library
 to propagate changes to the EDT. This package contains the development
 files.

Package: liboctovis1.8
Architecture: amd64 arm64 i386 mips mips64el mipsel powerpc ppc64el s390x alpha hppa hurd-i386 kfreebsd-amd64 kfreebsd-i386 m68k powerpcspe ppc64 sh4 sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Visualization library for OctoMap 
 Visualization library for the OctoMap library based on Qt and libQGLViewer.
 This library encapsulates the functions to view a Octomap octrees. It
 provides an API to visualizate the octree.

Package: liboctovis-dev
Architecture: amd64 arm64 i386 mips mips64el mipsel powerpc ppc64el s390x alpha hppa hurd-i386 kfreebsd-amd64 kfreebsd-i386 m68k powerpcspe ppc64 sh4 sparc64 x32
Section: libdevel  
Depends: liboctovis1.8 (= ${binary:Version}),
         ${misc:Depends}
Description: Visualization library for OctoMap development files
 Visualization library for the OctoMap library based on Qt and libQGLViewer.
 This library encapsulates the functions to view a Octomap octrees. This package 
 contains the development files.

Package: octovis
Architecture: amd64 arm64 i386 mips mips64el mipsel powerpc ppc64el s390x alpha hppa hurd-i386 kfreebsd-amd64 kfreebsd-i386 m68k powerpcspe ppc64 sh4 sparc64 x32
Depends: liboctovis1.8 (= ${binary:Version}),
         ${misc:Depends}, ${shlibs:Depends},
Description: Visualization tool for OctoMap
 Visualization library for the OctoMap library based on Qt and libQGLViewer.
 This package contains the tool for visualization. It's a viewer that lets
 you view an OctoMap.

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_OPTIONS += nocheck

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filterparallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

CMAKE_FLAGS = \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_VERBOSE_MAKEFILE=ON \
        -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
        -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
        -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
        -DCMAKE_SKIP_INSTALL_RPATH=TRUE
%:
	dh $@ --builddirectory=build --buildsystem=cmake --parallel

override_dh_clean:
	rm -rf build bin lib
	dh_clean

override_dh_auto_configure:
	mkdir -p build
	dh_auto_configure --builddirectory=build -- $(CMAKE_FLAGS) $(CMAKE_ARCH_FLAGS)


override_dh_auto_build:
	cd build && $(MAKE) 

override_dh_auto_install:
	dh_auto_install --builddirectory=build

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/liboctomap1.8 debian/tmp/usr/share/doc/libdynamicedt3d1.8
	gzip -n -c -9 octomap/CHANGELOG.txt > debian/tmp/usr/share/doc/liboctomap1.8/changelog.gz
	gzip -n -c -9 dynamicEDT3D/CHANGELOG.txt > debian/tmp/usr/share/doc/libdynamicedt3d1.8/changelog.gz
	dh_install --list-missing

override_dh_auto_test:
	echo "Supressing upstream tests"

get-orig-source:
	uscan --verbose --force-download --repack --compress xz


override_dh_installdocs:
	dh_installdocs -pliboctovis-dev --link-doc=liboctomap1.8
	dh_installdocs -poctomap-tools --link-doc=liboctomap1.8
	dh_installdocs -pliboctovis1.8 --link-doc=liboctomap1.8
	dh_installdocs -poctovis --link-doc=liboctomap1.8
	dh_installdocs -pliboctomap-dev --link-doc=liboctomap1.8
	dh_installdocs -plibdynamicedt3d-dev --link-doc=libdynamicedt3d1.8
	dh_installdocs
